<?php
namespace OrganizationsManagement\Factory;
use Teknisa\Model\Teknisa\Entities\SlaClienteParam as SlaClienteParamEntity;
use OrganizationsManagement\Util\InstanceProvider;

class SlaclienteParam
{

    /**
     * @param $cdcliente
     * @param $idControlaSla
     * @param $idParamSla
     * @param $nrorg
     * @param $currentOperator
     * @param $dtAtual
     * @param $idativo
     * @return SlaClienteParamEntity
     */
    public function create($cdcliente, $idControlaSla, $idParamSla, $nrorg, $currentOperator, $dtAtual, $idativo = 'S'): SlaClienteParamEntity
    {
        $idParamSla = $idParamSla ?? 'P';
        $entitie = new SlaClienteParamEntity;
        $entitie->setcdcliente($cdcliente);
        $entitie->setIdControlaSla($idControlaSla);
        $entitie->setidParamSla($idParamSla);

        $entitie->setNrorg($nrorg);
        $entitie->setDtinclusao($dtAtual);
        $entitie->setDtultatu($dtAtual);
        $entitie->setNrorginclusao($nrorg);
        $entitie->setCdoperinclusao($currentOperator);
        $entitie->setNrorgultatu($nrorg);
        $entitie->setCdoperultatu($currentOperator);
        $entitie->setIdativo($idativo);
        return $entitie;
    }

    /**
     * @param SlaClienteParamEntity $slaClienteParam
     * @param $idControlaSla
     * @param $idParamSla
     * @param $nrorg
     * @param $currentOperator
     * @param $dtAtual
     * @param $idativo
     * @return SlaClienteParamEntity
     */
    public function update(SlaClienteParamEntity $slaClienteParam, $idControlaSla,
                           $idParamSla, $nrorg, $currentOperator, $dtAtual, $idativo): SlaClienteParamEntity
    {
        $slaClienteParam->setIdControlaSla($idControlaSla);
        $slaClienteParam->setidParamSla($idParamSla);
        $slaClienteParam->setNrorg($nrorg);
        $slaClienteParam->setDtultatu($dtAtual);
        $slaClienteParam->setNrorgultatu($nrorg);
        $slaClienteParam->setCdoperultatu($currentOperator);
        $slaClienteParam->setIdativo($idativo);
        return $slaClienteParam;
    }
}
