<?php

namespace OrganizationsManagement\Service;

use Exception;
use OrganizationsManagement\Util\Utilities;
use OrganizationsManagement\Util\InstanceProvider;
use Doctrine\ORM\EntityManager;

class SlaclienteParam
{
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * SlaclienteParam constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findSlaclienteParam(): array
    {
        return InstanceProvider::getRepository()->getSlaclienteParam()->findSlaclienteParam();
    }

    /**
     * @param $rows
     * @throws Exception
     */
    public function saveSlaclienteParam($rows)
    {
        $slaclienteParamRepository = InstanceProvider::getRepository()->getSlaclienteParam();
        $slaclienteParamFactory = InstanceProvider::getFactory()->getSlaclienteParam();
        $environment     = InstanceProvider::getLibEnvironment();
        $nrorg    = $environment->getCurrentOrganizationId();
        $currentOperator = $environment->getCurrentUserId();
        $dtAtual = new \DateTime();
        try {
            foreach ($rows as $row) {
                /** @var \Teknisa\Model\Teknisa\Entities\SlaClienteParam $slaclienteParam */
                $slaclienteParam = $slaclienteParamRepository->findOneBy(array('cdcliente' => $row['CDCLIENTE']));
                $idParamSla = empty($row['ID_PARAM_SLA']) ? 'P' : $row['ID_PARAM_SLA'];
                if(empty($slaclienteParam)) {
                    $slaclienteParam = $slaclienteParamFactory->create($row['CDCLIENTE'], $row['ID_CONTROLA_SLA'], $idParamSla,
                        $nrorg, $currentOperator, $dtAtual, 'S');
                } else {
                    $slaclienteParam = $slaclienteParamFactory->update($slaclienteParam, $row['ID_CONTROLA_SLA'], $idParamSla,
                        $nrorg, $currentOperator, $dtAtual, 'S');
                }
                $this->entityManager->persist($slaclienteParam);
            }
            $this->entityManager->flush();
        } catch(Exception $e) {
            throw new Exception($e->getMessage());
        }
    }
}
