/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRUPOPER                                                 */
/* Tabela : GRUPOPER                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GRUPOPER' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GRUPOPER
GO

CREATE TRIGGER DTULTATU_GRUPOPER
ON GRUPOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GRUPOPER', null, 'CDGRUPOPER=' + CDGRUPOPER + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GRUPOPER
      SET DTULTATUGROP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(GRUPOPER.CDGRUPOPER,0)   = ISNULL(INSERTED.CDGRUPOPER,0  )) AND
            (ISNULL(GRUPOPER.DSGRUPOPER,0)   = ISNULL(INSERTED.DSGRUPOPER,0  )) AND
            (ISNULL(GRUPOPER.IDUTCTRSENOP,0) = ISNULL(INSERTED.IDUTCTRSENOP,0)) AND
            (ISNULL(GRUPOPER.DSSENHACAIXA,0) = ISNULL(INSERTED.DSSENHACAIXA,0));
   END;
END;
GO

UPDATE GRUPOPER SET DTULTATUGROP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUGROP IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUGROP' and
            type = 'D')
   ALTER TABLE GRUPOPER DROP CONSTRAINT DEFAULT_DTULTATUGROP
GO

ALTER TABLE GRUPOPER ADD CONSTRAINT DEFAULT_DTULTATUGROP
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUGROP
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_GRUPOPER','4.11.194';
GO

